Compare commits

..

No commits in common. "master" and "v0.1.1" have entirely different histories.

21 changed files with 225 additions and 381 deletions

View File

@ -1,38 +0,0 @@
name: Java CI with Gradle
on:
push:
branches: ["master"]
pull_request:
branches: ["master"]
jobs:
build:
runs-on: archlinux-latest
steps:
- name: Install prerequisite packages
run: pacman -Syu --noconfirm && pacman -S --noconfirm git nodejs
- name: Checkout repository
uses: actions/checkout@v4
- name: Set up JDK 21
uses: actions/setup-java@v4
with:
java-version: "21"
distribution: "temurin"
- name: Setup Gradle
uses: gradle/actions/setup-gradle@v4
- name: Build with Gradle Wrapper
run: ./gradlew build
# - name: Upload build artifacts
# uses: actions/upload-artifact@v4
# with:
# name: JARs
# path: build/libs
# retention-days: 30
# compression-level: 9

20
.gitignore vendored
View File

@ -1,21 +1,11 @@
# IntelliJ IDEA stuff
.idea/
# VSCode stuff
.vscode/
# Dolphin stuff
.directory
# Gradle project-specific cache directory
# Ignore Gradle project-specific cache directory
.gradle/
# Gradle build output directory
# Ignore Gradle build output directory
build/
bin/
# Run directory
# Ignore run directory
run/
# Remapped source file directory
remappedSrc/
# IntelliJ IDEA
.idea/

30
LICENSE
View File

@ -1,21 +1,15 @@
MIT License
HotbarReplace Minecraft Mod
Copyright (C) 2023 Adam Macdonald
Copyright (c) 2024 Adam Macdonald
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
You should have received a copy of the GNU General Public License
along with this program. If not, see <https://www.gnu.org/licenses/>.

View File

@ -1,18 +1,8 @@
## HotbarReplace
[![Java CI with Gradle](https://git.2khz.xyz/adam/HotbarReplace/actions/workflows/gradle.yml/badge.svg)](https://git.2khz.xyz/adam/HotbarReplace/actions/workflows/gradle.yml)
HotbarReplace is a Minecraft mod for the Fabric modding framework which replaces blocks in your hotbar with blocks of the same type from your inventory upon running out while placing, see demo GIF below to see how it works!
HotbarReplace is a Minecraft mod for the Fabric modding framework which replaces blocks in your hotbar with blocks of the same type from your inventory.
### Known issues/Improvements
* [You tell me!](https://git.2khz.xyz/adam/HotbarReplace/issues) I'd like to see this mod be as simple & bug-free as possible!
### Where to find it?
- Here! On GitHub you can grab whichever release you like from the sidebar on the right-hand side.
- Otherwise, also on [Modrinth](https://modrinth.com/mod/hotbarreplace).
#### Demo GIF
![HotbarReplace Demo GIF](./docs/hotbarreplace-demo.gif)
* The mod won't refill your hotbar slot with other stacks in other hotbar slots
* Make the mod more resilient to network delay and packet loss (don't hardcode a 50 ms delay)

View File

@ -1,37 +1,38 @@
// https://github.com/FabricMC/fabric-example-mod/blob/9b028bdcd43190d4f848d5898b89177de6776535/build.gradle#L1
plugins {
id 'fabric-loom' version '1.10-SNAPSHOT'
id 'fabric-loom' version '1.1-SNAPSHOT'
id 'maven-publish'
}
sourceCompatibility = JavaVersion.VERSION_17
targetCompatibility = JavaVersion.VERSION_17
archivesBaseName = project.archives_base_name
version = project.mod_version
group = project.maven_group
base {
archivesName = project.archives_base_name
}
repositories {
// ...
}
loom {
splitEnvironmentSourceSets()
mods {
"hotbarreplace" {
// sourceSet sourceSets.main
sourceSet sourceSets.client
}
}
// Add repositories to retrieve artifacts from in here.
// You should only use this when depending on other mods because
// Loom adds the essential maven repositories to download Minecraft and libraries from automatically.
// See https://docs.gradle.org/current/userguide/declaring_repositories.html
// for more information about repositories.
}
dependencies {
// To change the versions see the gradle.properties file
minecraft "com.mojang:minecraft:${project.minecraft_version}"
mappings "net.fabricmc:yarn:${project.yarn_mappings}:v2"
modImplementation "net.fabricmc:fabric-loader:${project.loader_version}"
// Fabric API. This is technically optional, but you probably want it anyway.
modImplementation "net.fabricmc.fabric-api:fabric-api:${project.fabric_version}"
// Uncomment the following line to enable the deprecated Fabric API modules.
// These are included in the Fabric API production distribution and allow you to update your mod to the latest modules at a later more convenient time.
// modImplementation "net.fabricmc.fabric-api:fabric-api-deprecated:${project.fabric_version}"
}
processResources {
@ -43,31 +44,36 @@ processResources {
}
tasks.withType(JavaCompile).configureEach {
it.options.release = 21
// Minecraft 1.18 (1.18-pre2) upwards uses Java 17.
it.options.release = 17
}
java {
// Loom will automatically attach sourcesJar to a RemapSourcesJar task and to the "build" task
// if it is present.
// If you remove this line, sources will not be generated.
withSourcesJar()
sourceCompatibility = JavaVersion.VERSION_21
targetCompatibility = JavaVersion.VERSION_21
}
jar {
from("LICENSE") {
rename { "${it}_${project.base.archivesName.get()}"}
rename { "${it}_${project.archivesBaseName}"}
}
}
// configure the maven publication
publishing {
publications {
create("mavenJava", MavenPublication) {
artifactId = project.archives_base_name
mavenJava(MavenPublication) {
from components.java
}
}
// See https://docs.gradle.org/current/userguide/publishing_maven.html for information on how to set up publishing.
repositories {
// ...
// Add repositories to publish to here.
// Notice: This block does NOT have the same function as the block in the top level.
// The repositories here will be used for publishing your artifact, not for
// retrieving dependencies.
}
}

Binary file not shown.

Before

Width:  |  Height:  |  Size: 8.7 MiB

View File

@ -1,16 +1,19 @@
# Done to increase the memory available to Gradle
# https://github.com/FabricMC/fabric-example-mod/blob/9b028bdcd43190d4f848d5898b89177de6776535/gradle.properties#L1
# Done to increase the memory available to gradle.
org.gradle.jvmargs=-Xmx1G
org.gradle.parallel=true
# Fabric Properties
minecraft_version=1.21.5
yarn_mappings=1.21.5+build.1
loader_version=0.16.13
# check these on https://fabricmc.net/develop
minecraft_version=1.19.3
yarn_mappings=1.19.3+build.5
loader_version=0.14.17
# Mod Properties
mod_version = 0.1.5
maven_group = xyz.twokilohertz
mod_version = 0.1.1
maven_group = io.github.twokilohertz.hotbarreplace
archives_base_name = HotbarReplace
# Dependencies
fabric_version=0.121.0+1.21.5
fabric_version=0.76.0+1.19.3

Binary file not shown.

View File

@ -1,7 +1,6 @@
distributionBase=GRADLE_USER_HOME
distributionPath=wrapper/dists
distributionUrl=https\://services.gradle.org/distributions/gradle-8.13-bin.zip
distributionUrl=https\://services.gradle.org/distributions/gradle-8.0.2-bin.zip
networkTimeout=10000
validateDistributionUrl=true
zipStoreBase=GRADLE_USER_HOME
zipStorePath=wrapper/dists

33
gradlew vendored Executable file → Normal file
View File

@ -15,8 +15,6 @@
# See the License for the specific language governing permissions and
# limitations under the License.
#
# SPDX-License-Identifier: Apache-2.0
#
##############################################################################
#
@ -57,7 +55,7 @@
# Darwin, MinGW, and NonStop.
#
# (3) This script is generated from the Groovy template
# https://github.com/gradle/gradle/blob/HEAD/platforms/jvm/plugins-application/src/main/resources/org/gradle/api/internal/plugins/unixStartScript.txt
# https://github.com/gradle/gradle/blob/HEAD/subprojects/plugins/src/main/resources/org/gradle/api/internal/plugins/unixStartScript.txt
# within the Gradle project.
#
# You can find Gradle at https://github.com/gradle/gradle/.
@ -85,8 +83,10 @@ done
# This is normally unused
# shellcheck disable=SC2034
APP_BASE_NAME=${0##*/}
# Discard cd standard output in case $CDPATH is set (https://github.com/gradle/gradle/issues/25036)
APP_HOME=$( cd -P "${APP_HOME:-./}" > /dev/null && printf '%s\n' "$PWD" ) || exit
APP_HOME=$( cd "${APP_HOME:-./}" && pwd -P ) || exit
# Add default JVM options here. You can also use JAVA_OPTS and GRADLE_OPTS to pass JVM options to this script.
DEFAULT_JVM_OPTS='"-Xmx64m" "-Xms64m"'
# Use the maximum available, or set MAX_FD != -1 to use that value.
MAX_FD=maximum
@ -133,21 +133,18 @@ location of your Java installation."
fi
else
JAVACMD=java
if ! command -v java >/dev/null 2>&1
then
die "ERROR: JAVA_HOME is not set and no 'java' command could be found in your PATH.
which java >/dev/null 2>&1 || die "ERROR: JAVA_HOME is not set and no 'java' command could be found in your PATH.
Please set the JAVA_HOME variable in your environment to match the
location of your Java installation."
fi
fi
# Increase the maximum file descriptors if we can.
if ! "$cygwin" && ! "$darwin" && ! "$nonstop" ; then
case $MAX_FD in #(
max*)
# In POSIX sh, ulimit -H is undefined. That's why the result is checked to see if it worked.
# shellcheck disable=SC2039,SC3045
# shellcheck disable=SC3045
MAX_FD=$( ulimit -H -n ) ||
warn "Could not query maximum file descriptor limit"
esac
@ -155,7 +152,7 @@ if ! "$cygwin" && ! "$darwin" && ! "$nonstop" ; then
'' | soft) :;; #(
*)
# In POSIX sh, ulimit -n is undefined. That's why the result is checked to see if it worked.
# shellcheck disable=SC2039,SC3045
# shellcheck disable=SC3045
ulimit -n "$MAX_FD" ||
warn "Could not set maximum file descriptor limit to $MAX_FD"
esac
@ -200,15 +197,11 @@ if "$cygwin" || "$msys" ; then
done
fi
# Add default JVM options here. You can also use JAVA_OPTS and GRADLE_OPTS to pass JVM options to this script.
DEFAULT_JVM_OPTS='"-Xmx64m" "-Xms64m"'
# Collect all arguments for the java command:
# * DEFAULT_JVM_OPTS, JAVA_OPTS, and optsEnvironmentVar are not allowed to contain shell fragments,
# and any embedded shellness will be escaped.
# * For example: A user cannot expect ${Hostname} to be expanded, as it is an environment variable and will be
# treated as '${Hostname}' itself on the command line.
# Collect all arguments for the java command;
# * $DEFAULT_JVM_OPTS, $JAVA_OPTS, and $GRADLE_OPTS can contain fragments of
# shell script including quotes and variable substitutions, so put them in
# double quotes to make sure that they get re-expanded; and
# * put everything else in single quotes, so that it's not re-expanded.
set -- \
"-Dorg.gradle.appname=$APP_BASE_NAME" \

22
gradlew.bat vendored
View File

@ -13,8 +13,6 @@
@rem See the License for the specific language governing permissions and
@rem limitations under the License.
@rem
@rem SPDX-License-Identifier: Apache-2.0
@rem
@if "%DEBUG%"=="" @echo off
@rem ##########################################################################
@ -45,11 +43,11 @@ set JAVA_EXE=java.exe
%JAVA_EXE% -version >NUL 2>&1
if %ERRORLEVEL% equ 0 goto execute
echo. 1>&2
echo ERROR: JAVA_HOME is not set and no 'java' command could be found in your PATH. 1>&2
echo. 1>&2
echo Please set the JAVA_HOME variable in your environment to match the 1>&2
echo location of your Java installation. 1>&2
echo.
echo ERROR: JAVA_HOME is not set and no 'java' command could be found in your PATH.
echo.
echo Please set the JAVA_HOME variable in your environment to match the
echo location of your Java installation.
goto fail
@ -59,11 +57,11 @@ set JAVA_EXE=%JAVA_HOME%/bin/java.exe
if exist "%JAVA_EXE%" goto execute
echo. 1>&2
echo ERROR: JAVA_HOME is set to an invalid directory: %JAVA_HOME% 1>&2
echo. 1>&2
echo Please set the JAVA_HOME variable in your environment to match the 1>&2
echo location of your Java installation. 1>&2
echo.
echo ERROR: JAVA_HOME is set to an invalid directory: %JAVA_HOME%
echo.
echo Please set the JAVA_HOME variable in your environment to match the
echo location of your Java installation.
goto fail

View File

@ -1,3 +1,14 @@
/*
* This file was generated by the Gradle 'init' task.
*
* The settings file is used to specify which projects to include in your build.
*
* Detailed information about configuring a multi-project build in Gradle can be found
* in the user manual at https://docs.gradle.org/8.0.2/userguide/multi_project_builds.html
*/
// https://github.com/FabricMC/fabric-example-mod/blob/9b028bdcd43190d4f848d5898b89177de6776535/settings.gradle#L1
pluginManagement {
repositories {
maven {

View File

@ -1,68 +0,0 @@
package xyz.twokilohertz;
import net.fabricmc.api.ClientModInitializer;
import net.minecraft.client.MinecraftClient;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.entity.player.PlayerInventory;
import net.minecraft.item.Item;
import net.minecraft.screen.slot.SlotActionType;
import net.minecraft.util.Hand;
import org.lwjgl.glfw.GLFW;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;
public class HotbarReplace implements ClientModInitializer {
public static final Logger LOGGER = LoggerFactory.getLogger("hotbarreplace");
private static final MinecraftClient client = MinecraftClient.getInstance();
private static final ScheduledExecutorService scheduler = Executors.newSingleThreadScheduledExecutor();
@Override
public void onInitializeClient() {
LOGGER.info("HotbarReplace v0.1.5 initialised");
}
public static void tryReplaceSlot(PlayerEntity player, Hand hand, Item item) {
// Return immediately if player is a spectator or in creative
if (player == null || player.isSpectator() || player.getAbilities().creativeMode)
return;
// Get reference to player's current inventory
PlayerInventory inventory = player.getInventory();
// Return if the inventory is empty
if (inventory == null || inventory.isEmpty() || player.currentScreenHandler == null)
return;
// Attempt to find a stack of matching items in the player's inventory
for (int i = 0; i < player.currentScreenHandler.slots.size(); i++) {
if (player.currentScreenHandler.slots.get(i).getStack().isOf(item)) {
// Simulate moving the stack from one slot to another
if (client == null)
return;
// TODO: This still feels like a bit of a hack
// I honestly do not know Minecraft internals enough to be sure that there won't
// be de-sync issues.
final int click_delay_ms = 50;
client.interactionManager.clickSlot(player.currentScreenHandler.syncId, i, GLFW.GLFW_MOUSE_BUTTON_1,
SlotActionType.PICKUP, player);
int slot = (hand == Hand.OFF_HAND ? 9 : inventory.getSelectedSlot());
scheduler.schedule(() -> client.interactionManager.clickSlot(player.currentScreenHandler.syncId,
slot + PlayerInventory.MAIN_SIZE, GLFW.GLFW_MOUSE_BUTTON_1,
SlotActionType.PICKUP, player), click_delay_ms, TimeUnit.MILLISECONDS);
return;
}
}
}
}

View File

@ -1,136 +0,0 @@
package xyz.twokilohertz.mixin;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.entity.LivingEntity;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.item.ItemUsageContext;
import net.minecraft.util.ActionResult;
import net.minecraft.util.Hand;
import net.minecraft.world.World;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import xyz.twokilohertz.HotbarReplace;
@Mixin(ItemStack.class)
public class ItemStackMixin {
Item lastUsedItem = null;
@Inject(at = @At("HEAD"), method = "use")
private void ItemStack_use_HEAD(World world, PlayerEntity player, Hand hand,
CallbackInfoReturnable<ActionResult> info) {
if (!world.isClient())
return;
Item item = player.getStackInHand(hand).getItem();
if (item == null)
return;
lastUsedItem = item;
}
@Inject(at = @At("HEAD"), method = "useOnBlock")
private void ItemStack_useOnBlock_HEAD(ItemUsageContext context,
CallbackInfoReturnable<ActionResult> info) {
if (!context.getWorld().isClient())
return;
Item item = context.getPlayer().getStackInHand(context.getHand()).getItem();
if (item == null)
return;
lastUsedItem = item;
}
@Inject(at = @At("HEAD"), method = "useOnEntity")
private void ItemStack_useOnEntity_HEAD(PlayerEntity player, LivingEntity entity, Hand hand,
CallbackInfoReturnable<ActionResult> info) {
if (!player.getWorld().isClient())
return;
Item item = player.getStackInHand(hand).getItem();
if (item == null)
return;
lastUsedItem = item;
}
@Inject(at = @At("TAIL"), method = "use")
private void ItemStack_use_TAIL(World world, PlayerEntity player, Hand hand,
CallbackInfoReturnable<ActionResult> info) {
if (!world.isClient())
return;
if (info.getReturnValue() != ActionResult.SUCCESS)
return;
ItemStack stack = player.getStackInHand(hand);
if (stack.getCount() > 1)
return;
HotbarReplace.tryReplaceSlot(player, hand, lastUsedItem);
}
@Inject(at = @At("TAIL"), method = "useOnBlock")
private void ItemStack_useOnBlock_TAIL(ItemUsageContext context, CallbackInfoReturnable<ActionResult> info) {
if (!context.getWorld().isClient())
return;
if (info.getReturnValue() != ActionResult.SUCCESS)
return;
PlayerEntity player = context.getPlayer();
Hand hand = context.getHand();
ItemStack stack = player.getStackInHand(hand);
if (stack.getCount() != 0)
return;
HotbarReplace.tryReplaceSlot(player, hand, lastUsedItem);
}
@Inject(at = @At("TAIL"), method = "useOnEntity")
private void ItemStack_useOnEntity_TAIL(PlayerEntity player, LivingEntity entity, Hand hand,
CallbackInfoReturnable<ActionResult> info) {
if (info.getReturnValue() != ActionResult.SUCCESS)
return;
ItemStack stack = player.getStackInHand(hand);
if (stack.getCount() > 1)
return;
HotbarReplace.tryReplaceSlot(player, hand, lastUsedItem);
}
@Inject(at = @At("HEAD"), method = "Lnet/minecraft/item/ItemStack;finishUsing(Lnet/minecraft/world/World;Lnet/minecraft/entity/LivingEntity;)Lnet/minecraft/item/ItemStack;")
private void ItemStack_finishUsing_HEAD(World world, LivingEntity user,
CallbackInfoReturnable<ItemStack> info) {
if (!world.isClient())
return;
ItemStack stack = (ItemStack) (Object) this;
// ItemStack stack = info.getReturnValue(); -- only applicable when injecting at TAIL
if (lastUsedItem != stack.getItem())
return;
// Food items disappear into thin (minecraft:)air before their stack size reaches 0
if (stack.getCount() > 1)
return;
if (!user.isPlayer())
return;
PlayerEntity player = (PlayerEntity) user;
if (!player.isMainPlayer())
return;
HotbarReplace.tryReplaceSlot(player, player.getActiveHand(), lastUsedItem);
}
}

Binary file not shown.

Before

Width:  |  Height:  |  Size: 1.8 KiB

View File

@ -1,13 +0,0 @@
{
"required": true,
"package": "xyz.twokilohertz.mixin",
"compatibilityLevel": "JAVA_21",
"mixins": [],
"client": [
"ItemStackMixin"
],
"server": [],
"injectors": {
"defaultRequire": 1
}
}

View File

@ -0,0 +1,68 @@
package io.github.twokilohertz.hotbarreplace;
import net.fabricmc.api.ModInitializer;
import net.minecraft.client.MinecraftClient;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.entity.player.PlayerInventory;
import net.minecraft.item.Item;
import net.minecraft.item.ItemPlacementContext;
import net.minecraft.item.ItemStack;
import net.minecraft.screen.slot.SlotActionType;
import org.lwjgl.glfw.GLFW;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;
public class HotbarReplace implements ModInitializer {
public static final Logger LOGGER = LoggerFactory.getLogger("hotbarreplace");
private static final MinecraftClient client = MinecraftClient.getInstance();
private static final ScheduledExecutorService scheduler = Executors.newSingleThreadScheduledExecutor();
@Override
public void onInitialize() {
LOGGER.info("HotbarReplace v0.1.1 initialised");
}
public static void tryReplaceSlot(ItemPlacementContext context, Item item) {
// Return immediately if player is a spectator
PlayerEntity player = context.getPlayer();
if (player.isSpectator()) return;
// Creative inventories don't run out of anyway
if (player.getAbilities().creativeMode) return;
// Get reference to player's current inventory
PlayerInventory inventory = player.getInventory();
if (inventory == null) return;
// Return if the inventory is empty
if (inventory.isEmpty()) return;
// Attempt to find a stack of matching items
for (int i = 0; i < inventory.main.size(); i++) {
if (i == inventory.selectedSlot) continue;
ItemStack stack = inventory.main.get(i);
if (stack.isOf(item)) {
// Simulate moving the stack from one slot to another
if (client != null) {
client.interactionManager.clickSlot(player.currentScreenHandler.syncId, i, GLFW.GLFW_MOUSE_BUTTON_1, SlotActionType.PICKUP, player);
/*
Wait 50 seconds (on another thread) before attempting to move the new stack
PlayerInventory.MAIN_SIZE added to the selected slot (hotbar slot) is the correct slot ID
*/
scheduler.schedule(() -> {
client.interactionManager.clickSlot(player.currentScreenHandler.syncId, inventory.selectedSlot + PlayerInventory.MAIN_SIZE, GLFW.GLFW_MOUSE_BUTTON_1, SlotActionType.PICKUP, player);
}, 50, TimeUnit.MILLISECONDS);
}
return;
}
}
}
}

View File

@ -0,0 +1,32 @@
package io.github.twokilohertz.hotbarreplace.mixin;
import net.minecraft.item.BlockItem;
import net.minecraft.item.Item;
import net.minecraft.item.ItemPlacementContext;
import net.minecraft.util.ActionResult;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import io.github.twokilohertz.hotbarreplace.HotbarReplace;
@Mixin(BlockItem.class)
public class BlockItemMixin {
private Item lastPlacedItem;
@Inject(at = @At("HEAD"), method = "Lnet/minecraft/item/BlockItem;place(Lnet/minecraft/item/ItemPlacementContext;)Lnet/minecraft/util/ActionResult;")
private void BlockItem_place_head(ItemPlacementContext context, CallbackInfoReturnable<ActionResult> info) {
lastPlacedItem = context.getStack().getItem();
}
@Inject(at = @At("TAIL"), method = "Lnet/minecraft/item/BlockItem;place(Lnet/minecraft/item/ItemPlacementContext;)Lnet/minecraft/util/ActionResult;")
private void mixin_BlockItem_place_tail(ItemPlacementContext context, CallbackInfoReturnable<ActionResult> info) {
// Early return if the block place action would fail
if (info.getReturnValue() != ActionResult.SUCCESS) return;
// Check if the stack is not empty, return if so
if (context.getStack().getCount() != 0) return;
// Try to replace the hotbar slot
HotbarReplace.tryReplaceSlot(context, lastPlacedItem);
}
}

Binary file not shown.

After

Width:  |  Height:  |  Size: 1.2 KiB

View File

@ -1,7 +1,8 @@
{
"schemaVersion": 1,
"id": "hotbarreplace",
"version": "0.1.5",
"version": "${version}",
"name": "HotbarReplace",
"description": "Replace blocks in your hotbar when you run out with blocks from your inventory",
"authors": [
@ -12,24 +13,24 @@
"sources": "https://github.com/twokilohertz/HotbarReplace",
"issues": "https://github.com/twokilohertz/HotbarReplace/issues"
},
"license": "MIT",
"license": "GPLv3",
"icon": "assets/hotbarreplace/icon.png",
"environment": "client",
"environment": "*",
"entrypoints": {
"client": [
"xyz.twokilohertz.HotbarReplace"
"main": [
"io.github.twokilohertz.hotbarreplace.HotbarReplace"
]
},
"mixins": [
{
"config": "hotbarreplace.mixins.json",
"environment": "client"
}
"hotbarreplace.mixins.json"
],
"depends": {
"fabricloader": ">=0.15.11",
"minecraft": "~1.21",
"java": ">=21",
"fabric-api": "*"
"fabricloader": ">=0.14.17",
"fabric-api": "*",
"minecraft": "~1.19.3",
"java": ">=17"
}
}

View File

@ -0,0 +1,14 @@
{
"required": true,
"minVersion": "0.8",
"package": "io.github.twokilohertz.hotbarreplace.mixin",
"compatibilityLevel": "JAVA_17",
"mixins": [
],
"client": [
"BlockItemMixin"
],
"injectors": {
"defaultRequire": 1
}
}